;macros.asm version:1.1 date:27-10-2007
;================================================
sz MACRO quoted_text:VARARG
	local local_text,lbl

	jmp lbl
	local_text	db	quoted_text,0
lbl:
	EXITM <offset local_text>
ENDM

dsz MACRO quoted_text:VARARG
	local local_text

	local_text	db	quoted_text,0
	EXITM <offset local_text>
ENDM

csz MACRO name_:REQ,quoted_text:VARARG
	local lbl

	jmp lbl
	name_		db	quoted_text,0
lbl:
ENDM

ssz MACRO quoted_text:VARARG
	local local_text,lbl

	jmp lbl
	local_text	db	quoted_text,0
lbl:
	EXITM <offset local_text,sizeof local_text>
ENDM

lsz MACRO quoted_text:VARARG
	local local_text,local_len,lbl
.data
	local_len	dd	?
.code
	jmp lbl
	local_text	db	quoted_text,0
lbl:
	invoke lstrlen,addr local_text
	mov local_len,eax
	EXITM <addr local_text,local_len>
ENDM

;================================================
return MACRO arg:REQ
	mov eax,arg
	ret
ENDM

m2m MACRO arg1:REQ,arg2:REQ
	push arg2
	pop   arg1
ENDM
;================================================
make_dword MACRO high_word:REQ,low_word:REQ
	local result,arg
.data
	result	dd	?
.code
	FOR arg, <high_word,low_word>	;; run thru args to see if ax is lurking in there
		IFIDNI <&arg>, <ax>
			.ERR <ax is not allowed as a parameter>
		ENDIF
	ENDM
	mov ax,high_word
	shl eax,16
	mov ax,low_word
	mov result,eax
	EXITM<result>
ENDM
;================================================
func MACRO the_function:VARARG
	local local_var
.data
	local_var dd ?
.code
	invoke the_function
	mov local_var,eax
	exitm <local_var>
ENDM
;================================================
func_ MACRO the_function:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22
  local local_var,arg
.data
	local_var dd ?
.code
	FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
		IFNB <arg>    ;; If not blank
			push arg    ;; push parameter
		ENDIF
	ENDM
	call the_function
	mov local_var,eax
	exitm <local_var>
ENDM
;================================================
rgb MACRO red:REQ,green:REQ,blue:REQ
	local _ret
.data
	_ret	dd	?
.code
	pushad
	push blue
	push green
	push red
	pop edx
	pop ecx
	pop eax
	shl eax,16
	mov ah,cl
	mov al,dl
	mov _ret,eax
	popad
	EXITM <_ret>
ENDM

flags_check MACRO src_flags:REQ,test_flags:REQ
	local local_var,arg
.data
	local_var	dd	?
.code
	FOR arg, <src_flags,test_flags>
		IFIDNI <&arg>,<eax>
			.ERR <eax is not allowed as a parameter>
		ENDIF
	ENDM
	mov eax,src_flags
	and eax,test_flags
	.if eax==test_flags
		mov local_var,TRUE
	.else
		mov local_var,FALSE
	.endif
	EXITM <local_var>
ENDM

abs MACRO value:req
	local exit_,start_loop,end_loop
	local local_var
.data
	local_var	dd	?
.code
	m2m local_var,value
	cmp local_var,0
	jge exit_
	mov eax,local_var
	xor ecx,ecx
start_loop:
	cmp eax,0
	je end_loop
	inc eax
	inc ecx
	jmp start_loop
end_loop:
	mov local_var,ecx
exit_:
	EXITM<local_var>
ENDM

MAKE_HRESULT MACRO sev,fac,code
	mov ecx, sev
	shl ecx, 31
	mov eax, fac
	shl eax, 16
	or eax, ecx
	or eax, code
ENDM

p2v MACRO _var:req,_pointer:req
	local arg

	FOR arg, <_var,_pointer>	;; run thru args to see if eax is lurking in there
		IFIDNI <&arg>, <eax>
			.ERR <eax is not allowed as a parameter>
		ENDIF
	ENDM

	mov eax,_pointer
	mov eax,dword ptr [eax]
	mov _var,eax
ENDM